import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
var _jsxFileName = "C:\\Dev\\20_gsoft\\sg-orbit\\packages\\react-components\\components\\multi-select\\src\\multi-select-selected-items.jsx";
import React from "react";
import { ITEM_SHAPE } from "./items";
import { PureComponent } from "react";
import { arrayOf, bool, func, shape, string } from "prop-types";
import { isNil } from "lodash";

class MultiSelectSelectedItem extends PureComponent {
  constructor() {
    super(...arguments);

    _defineProperty(this, "handleRemove", event => {
      const {
        item,
        onRemove
      } = this.props;
      onRemove(event, item, this.props);
    });
  }

  getClasses() {
    const {
      className
    } = this.props;
    const defaultClasses = "mr2 mb2";
    return isNil(className) ? defaultClasses : "".concat(defaultClasses, " ").concat(className);
  }

  render() {
    const {
      item,
      selectedItemRenderer,
      disabled
    } = this.props;
    return React.createElement("div", {
      className: this.getClasses(),
      __source: {
        fileName: _jsxFileName,
        lineNumber: 32
      },
      __self: this
    }, selectedItemRenderer(item, {
      disabled: disabled,
      onRemove: this.handleRemove
    }));
  }

}

export class MultiSelectSelectedItems extends PureComponent {
  constructor() {
    super(...arguments);

    _defineProperty(this, "handleRemoveSelectedItem", (event, item) => {
      const {
        onRemoveSelectedItem
      } = this.props;
      onRemoveSelectedItem(event, item);
    });
  }

  renderItems() {
    const {
      items,
      selectedItemRenderer,
      disabled,
      className
    } = this.props;
    return items.map(x => {
      return React.createElement(MultiSelectSelectedItem, {
        item: x,
        selectedItemRenderer: selectedItemRenderer,
        onRemove: this.handleRemoveSelectedItem,
        key: x.value,
        disabled: disabled,
        className: className,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 55
        },
        __self: this
      });
    });
  }

  render() {
    const {
      items
    } = this.props;

    if (items.length === 0) {
      return null;
    }

    return React.createElement(React.Fragment, null, this.renderItems());
  }

}