import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
var _jsxFileName = "C:\\Dev\\20_gsoft\\sg-orbit\\packages\\react-components\\components\\search-input\\src\\search-input-controller.jsx";
import _JSXStyle from "styled-jsx/style";
import React from "react";
import { AutoControlledPureComponent, KEYS, getAutoControlledStateFromProps, isNullOrEmpty } from "@orbit-ui/react-components-shared";
import { Button, Ref, Search } from "semantic-ui-react";
import { ClearIcon } from "@orbit-ui/icons";
import { RESULT_SHAPE } from "./results";
import { arrayOf, bool, func, node, number, shape, string } from "prop-types";
import { createRef } from "react";
import { debounce, isEmpty, isFunction, isNil } from "lodash";
import cx from "classnames";

function defaultResultRenderer(_ref) {
  let {
    text
  } = _ref;
  return React.createElement("div", {
    __source: {
      fileName: _jsxFileName,
      lineNumber: 11
    },
    __self: this
  }, text);
}

export class SearchInputController extends AutoControlledPureComponent {
  constructor() {
    super(...arguments);

    _defineProperty(this, "state", {
      transformedResults: [],
      value: null,
      query: null,
      renderPropagationFix: !this.props.disabled
    });

    _defineProperty(this, "_inputRef", createRef());

    _defineProperty(this, "_clearButtonRef", createRef());

    _defineProperty(this, "handleResultSelect", (event, data) => {
      const {
        clearOnSelect,
        onValueChange
      } = this.props;
      const selectedResult = JSON.parse(data.result.description);

      if (clearOnSelect) {
        this.trySetAutoControlledStateValue({
          value: null
        });
        this.setState({
          query: ""
        });
      } else {
        this.trySetAutoControlledStateValue({
          value: selectedResult.text
        });
        this.setState({
          query: selectedResult.text
        });
      }

      onValueChange(event, selectedResult, this.props);
    });

    _defineProperty(this, "handleSearchChange", (event, data) => {
      this.setState({
        query: data.value
      });

      if (!isNil(this.onSearch)) {
        this.onSearch(event, data.value, this.props);
      }
    });

    _defineProperty(this, "handleBlur", event => {
      const {
        onBlur,
        disabled
      } = this.props;

      const afterHandlingBlur = () => {
        if (!disabled) {
          this.setState({
            renderPropagationFix: true
          });
        }

        if (!isNil(onBlur)) {
          onBlur(event, this.props);
        }
      };

      if (!this._clearButtonRef.current.contains(event.relatedTarget)) {
        // Without a defered execution the selected value is always different than the typed value.
        setTimeout(() => {
          const {
            value,
            query
          } = this.state;

          if (isNil(value)) {
            if (!isNullOrEmpty(query)) {
              // When the user modified the query but didn't select any result and we dont know of any selected result, clear everything.
              this.trySetAutoControlledStateValue({
                value: null
              });
              this.setState({
                query: ""
              });
            }
          } else {
            // When the user modified the query but didn't select any result, reset the query to the last known selected result.
            if (value !== query) {
              this.setState({
                query: value
              });
            }
          }

          afterHandlingBlur();
        }, 0);
      } else {
        afterHandlingBlur();
      }
    });

    _defineProperty(this, "handleFocus", event => {
      const {
        onFocus
      } = this.props;

      if (!isNil(onFocus)) {
        onFocus(event, this.props);
      }
    });

    _defineProperty(this, "handleClear", event => {
      this.clear(event);
    });

    _defineProperty(this, "handleInputKeyDown", event => {
      const {
        onKeyDown
      } = this.props;

      switch (event.keyCode) {
        case KEYS.enter:
          this.handleInputEnter(event);
          break;

        case KEYS.esc:
          this.handleInputEscape(event);
          break;
      }

      if (!isNil(onKeyDown)) {
        onKeyDown(event, this.props);
      }
    });

    _defineProperty(this, "handleInputEnter", event => {
      const {
        loading
      } = this.props;
      const {
        query
      } = this.state;

      if (!loading) {
        if (isNullOrEmpty(query)) {
          this.clear(event);
        }
      }
    });

    _defineProperty(this, "handleInputEscape", event => {
      const {
        open
      } = this.props;

      if (open === false) {
        this.clear(event);
      }
    });

    _defineProperty(this, "handlePropagationFixFocus", () => {
      const {
        disabled
      } = this.props;

      if (!disabled) {
        this.setState({
          renderPropagationFix: false
        });
        setTimeout(() => {
          this._inputRef.current.focus();
        }, 0);
      }
    });

    _defineProperty(this, "onSearch", this.props.debounceDelay !== 0 ? debounce(this.props.onSearch, this.props.debounceDelay, {
      leading: true
    }) : this.props.onSearch);

    _defineProperty(this, "renderResult", result => {
      const {
        resultRenderer
      } = this.props;
      const data = JSON.parse(result.description);
      return resultRenderer(data);
    });

    _defineProperty(this, "renderPropagationFix", () => {
      const {
        disabled
      } = this.props;
      const {
        renderPropagationFix
      } = this.state;
      return React.createElement("div", {
        className: cx("absolute top-0 left-0 w-100 h-100 cursor-text o-0", {
          dn: !renderPropagationFix
        }),
        onFocus: this.handlePropagationFixFocus,
        tabIndex: disabled ? null : "0",
        __source: {
          fileName: _jsxFileName,
          lineNumber: 277
        },
        __self: this
      });
    });

    _defineProperty(this, "renderClearButton", () => {
      const {
        clearIcon
      } = this.props;
      return React.createElement("div", {
        className: "jsx-916403036" + " " + (cx("cancel-btn-container absolute", {
          dn: !this.canClear()
        }) || ""),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 289
        },
        __self: this
      }, React.createElement(Ref, {
        innerRef: this._clearButtonRef,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 290
        },
        __self: this
      }, React.createElement(Button, {
        circular: true,
        size: "mini",
        primary: true,
        icon: true,
        className: "transparent",
        onClick: this.handleClear,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 291
        },
        __self: this
      }, clearIcon)), React.createElement(_JSXStyle, {
        id: "916403036",
        __self: this
      }, ".cancel-btn-container.jsx-916403036{position:absolute;top:50%;right:calc(var(--scale-juliett) / 2);-webkit-transform:translateX(50%) translateY(-50%);-ms-transform:translateX(50%) translateY(-50%);transform:translateX(50%) translateY(-50%);}"));
    });
  }

  componentDidMount() {
    this.transformResults();
  }

  componentDidUpdate(prevProps) {
    const {
      results
    } = this.props; // This seems like a good opportunity to use "getDerivedStateFromProps" instead of "componentDidUpdate" to compute the transformed results.
    // It might not be since the shallow comparison of the results array will mostly returns false since the array reference will usually be different.
    // Knowing this, we will mostly end up transforming the results before EVERY render if we use "getDerivedStateFromProps".

    if (prevProps.results !== results) {
      this.transformResults();
    }
  }

  componentWillUnmount() {
    this.cancelOnSearchDebounce();
  }

  static getDerivedStateFromProps(props, state) {
    return getAutoControlledStateFromProps(props, state, SearchInputController.autoControlledProps, (_ref2) => {
      let {
        value
      } = _ref2;
      return {
        query: isNil(value) ? "" : value
      };
    });
  }

  transformResults() {
    const {
      results
    } = this.props; // YES, this is a weird hack.
    // Why do we do this? The current version of the search component render all the props that are not "title", "description", "price" or "image"
    // as a data properties on the result DOM elements.
    // Rendering those data properties generates a lot of React errors. React doesn't understand why he have to render a data properties called "userId" or "tenantId".
    // Until this is fixed, the solution is to provide all our custom properties as a JSON serialized string through the "description" property.
    // The issue for this matter is: https://github.com/Semantic-Org/Semantic-UI-React/issues/1141

    const transformedResults = results.map(x => ({
      title: x.text,
      description: JSON.stringify(x)
    }));
    this.setState({
      transformedResults: transformedResults
    });
  }

  cancelOnSearchDebounce() {
    if (isFunction(this.onSearch.cancel)) {
      this.onSearch.cancel();
    }
  }

  clear(event) {
    const {
      onValueChange
    } = this.props;
    const {
      value,
      query
    } = this.state;

    if (!isNullOrEmpty(query)) {
      this.setState({
        query: ""
      });
    }

    if (!isNil(value)) {
      this.trySetAutoControlledStateValue({
        value: null
      });
      onValueChange(event, null, this.props);
    }
  }

  canClear() {
    const {
      disabled
    } = this.props;
    const {
      query
    } = this.state;
    return !isEmpty(query) && !disabled;
  }

  getInputCssClasses() {
    const {
      className
    } = this.props;
    const inputDefaultClasses = "fluid";
    return isNil(className) ? inputDefaultClasses : "".concat(inputDefaultClasses, " ").concat(className);
  }

  render() {
    const {
      open,
      loading,
      disabled,
      noResultsMessage,
      minCharacters,
      placeholder,
      autofocus
    } = this.props;
    const {
      transformedResults,
      query
    } = this.state;
    return React.createElement("div", {
      className: "jsx-901502087" + " " + "search-input relative w-100",
      __source: {
        fileName: _jsxFileName,
        lineNumber: 313
      },
      __self: this
    }, React.createElement(Search, {
      open: open && !disabled,
      minCharacters: minCharacters,
      noResultsMessage: noResultsMessage,
      onResultSelect: this.handleResultSelect,
      onSearchChange: this.handleSearchChange,
      onBlur: this.handleBlur,
      resultRenderer: this.renderResult,
      results: transformedResults,
      value: query,
      input: {
        icon: loading && !disabled ? "" : "search",
        iconPosition: "left",
        className: this.getInputCssClasses(),
        onKeyDown: this.handleInputKeyDown,
        autoFocus: autofocus,
        ref: this._inputRef
      },
      placeholder: placeholder,
      disabled: disabled,
      loading: loading && !disabled,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 314
      },
      __self: this
    }), this.renderPropagationFix(), this.renderClearButton(), React.createElement(_JSXStyle, {
      id: "901502087",
      __self: this
    }, ".search-input.jsx-901502087 .prompt{padding-right:var(--scale-juliett) !important;}"));
  }

}

_defineProperty(SearchInputController, "propTypes", {
  open: bool,
  results: arrayOf(shape(RESULT_SHAPE)).isRequired,
  value: string,
  defaultValue: string,
  onValueChange: func.isRequired,
  onSearch: func.isRequired,
  onFocus: func,
  onBlur: func,
  onKeyDown: func,
  resultRenderer: func,
  clearOnSelect: bool,
  noResultsMessage: string,
  minCharacters: number,
  placeholder: string,
  debounceDelay: number,
  loading: bool,
  clearIcon: node,
  disabled: bool,
  autofocus: bool,
  className: string
});

_defineProperty(SearchInputController, "defaultProps", {
  resultRenderer: defaultResultRenderer,
  clearOnSelect: false,
  minCharacters: 1,
  placeholder: "Search",
  debounceDelay: 200,
  loading: false,
  clearIcon: React.createElement(ClearIcon, {
    className: "h3 w3",
    __source: {
      fileName: _jsxFileName,
      lineNumber: 45
    },
    __self: this
  }),
  disabled: false,
  autofocus: false
});

_defineProperty(SearchInputController, "autoControlledProps", ["value"]);