import _taggedTemplateLiteral from "@babel/runtime/helpers/esm/taggedTemplateLiteral";

function _templateObject11() {
  const data = _taggedTemplateLiteral(["", "", " is invalid."]);

  _templateObject11 = function _templateObject11() {
    return data;
  };

  return data;
}

function _templateObject10() {
  const data = _taggedTemplateLiteral(["", "", " must be a number."]);

  _templateObject10 = function _templateObject10() {
    return data;
  };

  return data;
}

function _templateObject9() {
  const data = _taggedTemplateLiteral(["", "", " must be a plain object."]);

  _templateObject9 = function _templateObject9() {
    return data;
  };

  return data;
}

function _templateObject8() {
  const data = _taggedTemplateLiteral(["", "", " must be an object."]);

  _templateObject8 = function _templateObject8() {
    return data;
  };

  return data;
}

function _templateObject7() {
  const data = _taggedTemplateLiteral(["", "", " must be an array."]);

  _templateObject7 = function _templateObject7() {
    return data;
  };

  return data;
}

function _templateObject6() {
  const data = _taggedTemplateLiteral(["", "", " must be a string."]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  const data = _taggedTemplateLiteral(["", "", " must be a function."]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  const data = _taggedTemplateLiteral(["", "", " cannot be empty."]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  const data = _taggedTemplateLiteral(["", "", " cannot be null."]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  const data = _taggedTemplateLiteral(["", "", " cannot be empty."]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  const data = _taggedTemplateLiteral(["", "", " cannot be null."]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

import { ArgumentError, ArgumentNullError } from "./throwable-errors";
import { IS_PRODUCTION } from "./env";
import { forOwn, isArray as _isArray, isFunction as _isFunction, isInteger, isNil, isObject as _isObject, isPlainObject as _isPlainObject, isString as _isString } from "lodash";
import { isNullOrEmpty } from "./types";
import { template } from "./strings";
const ASSERTION_DEFINITIONS = {
  /**
   * @example
   * ensure(parameter, "Optional parameter name", "Optional context").isNotNull("Optional specific message");
   */
  isNotNull: (parameter, parameterName, context, assertionMessage) => {
    if (isNil(parameter)) {
      const message = getMessage(assertionMessage, template(_templateObject(), 0, 1), parameterName, context);
      throw new ArgumentNullError(parameterName, message);
    }
  },

  /**
   * @example
   * ensure(parameter, "Optional parameter name", "Optional context").isNotEmpty("Optional specific message");
   */
  isNotEmpty: (parameter, parameterName, context, assertionMessage) => {
    let isValid = false;

    if (!isNil(parameter)) {
      isValid = true;
    } else if (_isArray(parameter)) {
      isValid = parameter.length > 0;
    } else {
      isValid = parameter !== "";
    }

    if (!isValid) {
      const message = getMessage(assertionMessage, template(_templateObject2(), 0, 1), parameterName, context);
      throw new ArgumentError(message);
    }
  },

  /**
   * @example
   * ensure(parameter, "Optional parameter name", "Optional context").isNotNullOrEmpty("Optional specific message");
   */
  isNotNullOrEmpty: (parameter, parameterName, context, assertionMessage) => {
    let message = "";

    if (isNil(parameter)) {
      message = getMessage(assertionMessage, template(_templateObject3(), 0, 1), parameterName, context);
      throw new ArgumentNullError(parameterName, message);
    }

    if (parameter === "") {
      message = getMessage(assertionMessage, template(_templateObject4(), 0, 1), parameterName, context);
      throw new ArgumentError(message);
    }
  },

  /**
   * @example
   * ensure(parameter, "Optional parameter name", "Optional context").isFunction("Optional specific message");
   */
  isFunction: (parameter, parameterName, context, assertionMessage) => {
    if (!isNil(parameter) && !_isFunction(parameter)) {
      const message = getMessage(assertionMessage, template(_templateObject5(), 0, 1), parameterName, context);
      throw new ArgumentError(message);
    }
  },

  /**
   * @example
   * ensure(parameter, "Optional parameter name", "Optional context").isString("Optional specific message");
   */
  isString: (parameter, parameterName, context, assertionMessage) => {
    if (!isNil(parameter) && !_isString(parameter)) {
      const message = getMessage(assertionMessage, template(_templateObject6(), 0, 1), parameterName, context);
      throw new ArgumentError(message);
    }
  },

  /**
   * @example
   * ensure(parameter, "Optional parameter name", "Optional context").isArray("Optional specific message");
   */
  isArray: (parameter, parameterName, context, assertionMessage) => {
    if (!isNil(parameter) && !_isArray(parameter)) {
      const message = getMessage(assertionMessage, template(_templateObject7(), 0, 1), parameterName, context);
      throw new ArgumentError(message);
    }
  },

  /**
   * @example
   * ensure(parameter, "Optional parameter name", "Optional context").isObject("Optional specific message");
   */
  isObject: (parameter, parameterName, context, assertionMessage) => {
    if (!isNil(parameter) && !_isObject(parameter)) {
      const message = getMessage(assertionMessage, template(_templateObject8(), 0, 1), parameterName, context);
      throw new ArgumentError(message);
    }
  },

  /**
   * @example
   * ensure(parameter, "Optional parameter name", "Optional context").isPlainObject("Optional specific message");
   */
  isPlainObject: (parameter, parameterName, context, assertionMessage) => {
    if (!isNil(parameter) && !_isPlainObject(parameter)) {
      const message = getMessage(assertionMessage, template(_templateObject9(), 0, 1), parameterName, context);
      throw new ArgumentError(message);
    }
  },

  /**
   * @example
   * ensure(parameter, "Optional parameter name", "Optional context").isNumber("Optional specific message");
   */
  isNumber: (parameter, parameterName, context, assertionMessage) => {
    if (!isNil(parameter) && !isInteger(parameter)) {
      const message = getMessage(assertionMessage, template(_templateObject10(), 0, 1), parameterName, context);
      throw new ArgumentError(message);
    }
  },

  /**
   * @example
   * ensure(parameter, "Optional parameter name", "Optional context").isTrue(// Can be a boolean or a function // () => { return true; }, "Optional specific message");
   */
  isTrue: (parameter, parameterName, context, evaluator, assertionMessage) => {
    let fct = evaluator;

    if (!_isFunction(evaluator)) {
      fct = x => {
        return !!x;
      };
    }

    if (!isNil(parameter) && !fct(parameter)) {
      const message = getMessage(assertionMessage, template(_templateObject11(), 0, 1), parameterName, context);
      throw new ArgumentError(message);
    }
  }
};

function getMessage(assertionMessage, defaultMessageTemplate, parameterName, context) {
  let message = assertionMessage;

  if (isNullOrEmpty(message)) {
    const param1 = isNullOrEmpty(context) ? "" : "".concat(context, " - ");
    const param2 = isNullOrEmpty(parameterName) ? "Parameter" : parameterName;
    message = defaultMessageTemplate(param1, param2);
  }

  return message;
}
/**
 * Ensure that a parameter respect the specified assertions.
 * @param {string} parameter - The parameter to verify.
 * @param {string} parameterName - The name of the parameter to verify.
 * @param {string} [context] - An identifier providing more information about the context of the call to ensure.
 * @return {Object} An object that contains all the assertions functions.
 * @example
 * ensure(parameter, "Optional parameter name", "Optional context")
 *      .isNotNull("Optional specific message")
 *      .isNotEmpty("Optional specific message")
 *      .isString("Optional specific message");
 */


export function ensure(parameter, parameterName, context) {
  const assertions = {};

  const getAssertionProxy = assertion => {
    return function () {
      if (!IS_PRODUCTION) {
        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        assertion(parameter, parameterName, context, ...args);
      }

      return assertions;
    };
  }; // Wrap all the assertions to append the default arguments to the function arguments.


  forOwn(ASSERTION_DEFINITIONS, (assertion, assertionKey) => {
    assertions[assertionKey] = getAssertionProxy(assertion);
  });
  return assertions;
}